//Find showpath and make it only execute if caller is admin or local player


void UXC_GameEngine::ReplaceShowPathFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplaceShowPathFunc);

	if ( b451Setup ) //Not needed in v451
		return;

	UFunction* ShowPath = FindBaseFunction( APlayerPawn::StaticClass(), TEXT("ShowPath"));
	if ( !ShowPath ) //Script not serialized?
		return;

	if ( OldShowPath.IsCleared() && (!bSet || !OldShowPath.Setup( &ShowPath->Script )) )
		return;
	
	if ( !bSet )
	{
		OldShowPath.Restore( &ShowPath->Script);
		if ( bEnableDebugLogs )
			debugf( NAME_XC_Engine, TEXT("Reverting PlayerPawn.ShowPath hook") );
		return;
	}
	else if ( OldShowPath.MismatchSize(&ShowPath->Script) )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* bAdmin = FindScriptVariable( APlayerPawn::StaticClass(), TEXT("bAdmin"), &Found);
	UProperty* Destination = FindScriptVariable( APlayerPawn::StaticClass(), TEXT("Destination"), &Found);
	UProperty* Level = FindScriptVariable( AActor::StaticClass(), TEXT("Level"), &Found);
	UProperty* NetMode = FindScriptVariable( ALevelInfo::StaticClass(), TEXT("NetMode"), &Found);
	UProperty* Location = FindScriptVariable( AActor::StaticClass(), TEXT("Location"), &Found);
//native(231) final static function Log( coerce string S, optional name Tag );
/*native(278) final function actor Spawn
(
	class<actor>      SpawnClass,
	optional actor	  SpawnOwner,
	optional name     SpawnTag,
	optional vector   SpawnLocation,
	optional rotator  SpawnRotation
);
*/
	UProperty* node = FindScriptVariable( ShowPath, TEXT("node"), &Found);
	check( Found == 6 );
	UClass* WayBeacon = StaticLoadClass( AActor::StaticClass(), NULL, TEXT("Engine.WayBeacon") , NULL, LOAD_NoFail, NULL );
	if ( !WayBeacon )
	{
		debugf( NAME_XC_Engine, TEXT("Class Engine.WayBeacon not loaded, aborting ShowPath hook"));
		return;
	}

	ShowPath->Script.Empty();
	ShowPath->Script.AddZeroed( 126);

//	if ( bAdmin || Level.NetMode == NM_Standalone )
//	{
	BYTE* Block = &ShowPath->Script(0);
	JumpToIfNot( Block, 0x007C);			Block += 3; // (3)
	*Block++ = 0x84; // || (4)
	*Block++ = 0x2D; // EX_BoolVariable (5)
	ParseInstanceVariable( Block, bAdmin);	Block += 5; // (10)
	SkipAhead( Block, 0x15);				Block += 3; // (13)
	*Block++ = 0x9A; // int == int  (14)
	*Block++ = 0x3A; // EX_ByteToInt (15)
	_byte_SingleContext( Block, 1, Level);	Block += 9; // (24)
	ParseInstanceVariable( Block, NetMode);	Block += 5; // (29)
	*Block++ = 0x3A; // EX_ByteToInt (30)
	*Block++ = 0x24; // EX_ByteConst (31) ==== I SHOULD OPTIMIZE THIS SHIT AND DIRECTLY COMPARE TO INT!!!
	*Block++ = 0x00; // 0 constant (32)
	*Block++ = 0x16; // EX_EndFunctionParams (33)
	*Block++ = 0x16; // EX_EndFunctionParams (34)

//		node = FindPathTo(Destination);
	*Block++ = 0x0F; //	EX_Let (35)
	ParseLocalVariable( Block, node);		Block += 5; // (40)
	HighNative( Block, 518);				Block += 2; // (42)
	ParseInstanceVariable( Block, Destination);	Block += 5; // (47)
	*Block++ = 0x16; // EX_EndFunctionParams (48)

//		if (node != None)
//		{
	JumpToIfNot( Block, 0x0068);			Block += 3; // (51)
	*Block++ = 0x77; // object != object (52)
	ParseLocalVariable( Block, node);		Block += 5; // (57)
	*Block++ = 0x2A; // EX_NoObject (58)
	*Block++ = 0x16; // EX_EndFunctionParams (59)

//			log("found path");
	*Block++ = 0xE7; // Log (60)
	Block += StringConstant( Block, "found path"); // 12 bytes, (72)
	*Block++ = 0x16; // EX_EndFunctionParams (73)

//			Spawn(class 'WayBeacon', self, '', node.location); //implicit Self.Rotation in spawn function
	HighNative( Block, 278);				Block += 2; // (75)
	ObjectConstant( Block, WayBeacon);		Block += 5; // (80)
	*Block++ = 0x17; // EX_Self (81)
	*Block++ = 0x21; // EX_NameConstant (82)
	Block += 4; // 0x00000000 Name is NAME_None (86)
	_vector_SingleContext( Block, 0, node);	Block += 9; // (95)
	ParseInstanceVariable( Block, Location);	Block += 5; // (100)
	*Block++ = 0x16; // EX_EndFunctionParams (101)
	JumpTo( Block, 0x007C);					Block += 3; // (104)

//		else
//			Log("didn't find path");
	*Block++ = 0xE7; // Log (105)
	Block += StringConstant( Block, "didn't find path"); //18 bytes, (123)
	*Block++ = 0x16; // EX_EndFunctionParams (124)
	
	AddReturn( Block); // (126)

	if ( bEnableDebugLogs )
		debugf( NAME_XC_Engine, TEXT("PlayerPawn.ShowPath hook success"));
	unguard;
}
